var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/babel/src/index.ts
var src_exports = {};
__export(src_exports, {
  comptimeCssBabelPlugin: () => comptimeCssBabelPlugin
});
module.exports = __toCommonJS(src_exports);
var import_core3 = require("@babel/core");
var import_generator = __toESM(require("@babel/generator"));
var import_hash = __toESM(require("@emotion/hash"));

// packages/babel/src/utils.ts
var import_core = require("@babel/core");
var buildImport = (0, import_core.template)("import { %%specifier%% as %%alias%% } from %%source%%;");
var buildModuleExport = (0, import_core.template)("module.exports = %%nodes%%");
var buildNamedExport = (0, import_core.template)("export { %%ident%% }");
var buildComponentStyle = (0, import_core.template)(`
const %%className%% = %%recipeImport%%(%%styles%%);
`);
var buildComponent = (0, import_core.template)(`const %%component%% = %%styledImport%%(%%tag%%, %%className%%);`);
function invariant(cond, message) {
  if (!cond) {
    throw new Error(message);
  }
}

// packages/babel/src/visitors/styled-components.ts
var import_core2 = require("@babel/core");
function styledComponentsVisitor(programPath) {
  return {
    VariableDeclaration(variablePath) {
      const declarations = variablePath.get("declarations");
      if (declarations.length < 1)
        return;
      const decl = declarations[0].get("init");
      const id = declarations[0].get("id");
      if (!decl.isCallExpression())
        return;
      if (!id.isIdentifier())
        return;
      const isImportedFromLib = decl.get("callee").referencesImport("comptime-css-solid", "styled");
      if (!isImportedFromLib) {
        return;
      }
      invariant(decl.get("arguments").length === 2, "Wrong arguments to `styled`");
      const [tag, styles] = decl.get("arguments");
      const className = variablePath.scope.generateUidIdentifier(id.node.name.toLowerCase());
      const styledIdent = programPath.scope.generateUidIdentifier("$$styled");
      const recipeIdent = programPath.scope.generateUidIdentifier("recipe");
      const stmts = [
        buildImport({
          specifier: import_core2.types.identifier("$$styled"),
          alias: styledIdent,
          source: import_core2.types.stringLiteral("comptime-css-solid/runtime")
        }),
        buildImport({
          specifier: import_core2.types.identifier("recipe"),
          alias: recipeIdent,
          source: import_core2.types.stringLiteral("comptime-css")
        }),
        buildComponentStyle({
          recipeImport: recipeIdent,
          styles: styles.node,
          className
        })
      ];
      programPath.unshiftContainer("body", stmts);
      const component = buildComponent({
        component: id.node.name,
        styledImport: styledIdent,
        tag: import_core2.types.cloneNode(tag.node),
        className
      });
      variablePath.replaceWith(component);
      variablePath.scope.crawl();
    }
  };
}

// packages/babel/src/index.ts
function comptimeCssBabelPlugin(opts) {
  return {
    name: "comptime-css-babel",
    visitor: {
      Program: {
        enter(path, state) {
          state.dependentNodes = /* @__PURE__ */ new Set();
          state.styledNodes = [];
          path.traverse(styledComponentsVisitor(path), state);
        },
        exit(path, state) {
          let ast = buildModuleExport({
            nodes: import_core3.types.objectExpression(state.styledNodes.map((node) => import_core3.types.objectProperty(import_core3.types.identifier(node.ident), import_core3.types.identifier(node.ident))))
          });
          const program = import_core3.types.program([...state.dependentNodes, ast].map((path2) => {
            if (!("parent" in path2))
              return path2;
            if (path2.parent.type === "Program") {
              return path2.node;
            } else {
              return path2.parent;
            }
          }));
          let cssExtract = (0, import_generator.default)(program).code;
          let cssFile = `extracted_${(0, import_hash.default)(cssExtract)}.css.ts`;
          for (const name of state.styledNodes) {
            path.unshiftContainer("body", buildImport({
              specifier: import_core3.types.identifier(name.ident),
              alias: import_core3.types.identifier(name.ident),
              source: import_core3.types.stringLiteral(cssFile)
            }));
            if (name.shouldExport) {
              path.pushContainer("body", buildNamedExport({ ident: name.ident }));
            }
          }
          opts.result = [cssFile, cssExtract];
        }
      },
      VariableDeclaration(variablePath, variableState) {
        const declarations = variablePath.get("declarations");
        if (declarations.length < 1)
          return;
        const decl = declarations[0].get("init");
        const id = declarations[0].get("id");
        if (!decl.isCallExpression())
          return;
        if (!id.isArrayPattern() && !id.isIdentifier())
          return;
        const extractionAPIs = [
          "style",
          "styleVariants",
          "globalStyle",
          "createTheme",
          "createGlobalTheme",
          "createThemeContract",
          "createGlobalThemeContract",
          "assignVars",
          "createVar",
          "fallbackVar",
          "fontFace",
          "globalFontFace",
          "keyframes",
          "globalKeyframes",
          "style",
          "styleVariants",
          "globalStyle",
          "createTheme",
          "createGlobalTheme",
          "createThemeContract",
          "createGlobalThemeContract",
          "assignVars",
          "createVar",
          "fallbackVar",
          "fontFace",
          "globalFontFace",
          "keyframes",
          "globalKeyframes",
          "recipe"
        ];
        if (!extractionAPIs.some((api) => decl.get("callee").referencesImport("comptime-css", api))) {
          return;
        }
        for (const key in decl.scope.bindings) {
          const binding = decl.scope.bindings[key];
          if (binding && key) {
            variableState.dependentNodes.add(binding.path);
          }
        }
        const shouldExport = variablePath.parentPath.isExportNamedDeclaration();
        if (id.isArrayPattern()) {
          for (const elementPath of id.get("elements")) {
            if (elementPath.isIdentifier()) {
              variableState.styledNodes.push({
                shouldExport,
                ident: elementPath.node.name
              });
            }
          }
        } else {
          variableState.styledNodes.push({
            shouldExport,
            ident: id.node.name
          });
        }
        variablePath.remove();
      }
    }
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  comptimeCssBabelPlugin
});
//# sourceMappingURL=index.js.map